/* GCC */
#include <cstdio>
#include <algorithm>
#include <queue>

#define MAX 2000 + 1

using namespace std;

int edges[MAX][MAX];
int sizes[MAX];
int division[MAX];
int n, m;

void init(){
    freopen("wrappers.in", "r", stdin);
    freopen("wrappers.out", "w", stdout);
    scanf("%d%d", &n, &m);
    fill(sizes, sizes + n, 0);
    fill(division, division + n, 0);
    for(int i = 0; i < m; i++){
        int f, s;
        scanf("%d%d", &f, &s);
        f--;
        s--;
        edges[f][sizes[f]] = s;
        edges[s][sizes[s]] = f;
        sizes[f]++;
        sizes[s]++;
    }
}

bool bfs(int b){
    queue<int> ord;
    ord.push(b);
    while(!ord.empty()){
        int cur = ord.front();
        ord.pop();
        for(int i = 0; i < sizes[cur]; i++){
            int next = edges[cur][i];
            if(division[next] == 0){
                division[next] = 3 - division[cur];
                ord.push(next);
            }else if(division[next] == division[cur])
                return false;
        }
    }
    return true;
}

int main()
{
    init();
    for(int i = 0; i < n; i++){
        if(division[i] == 0){
            division[i] = 1;
            if(!bfs(i)){
                printf("0\n0\n");
                return 0;
            }
        }
    }
    bool first = true;
    for(int i = 0; i < n; i++){
        if(division[i] == 2)
            continue;
        if(first){
            printf("%d", i + 1);
            first = !first;
        }else
            printf(" %d", i + 1);
    }
    printf("\n");
    first = true;
    for(int i = 0; i < n; i++){
        if(division[i] == 1)
            continue;
        if(first){
            printf("%d", i + 1);
            first = !first;
        }else
            printf(" %d", i + 1);
    }
    printf("\n");

    return 0;
}
